--- old/usr/src/uts/common/fs/nfs/nfs4_srv_readdir.c	2016-09-14 16:21:03.196707385 +0200
+++ new/usr/src/uts/common/fs/nfs/nfs4_srv_readdir.c	2016-09-14 16:21:03.201222487 +0200
@@ -192,7 +192,7 @@
 		return (0);
 	}
 
-	newexi = checkexport4(&vp->v_vfsp->vfs_fsid, &fid, vp);
+	newexi = checkexport(&vp->v_vfsp->vfs_fsid, &fid, vp);
 	if (newexi == NULL) {
 		if (ismntpt == 0) {
 			*vpp = vp;
@@ -225,6 +225,7 @@
 
 	if (status != NFS4_OK) {
 		VN_RELE(vp);
+		exi_rele(newexi);
 		if (status == NFS4ERR_DELAY)
 			status = NFS4ERR_ACCESS;
 		return (status);
@@ -695,8 +696,10 @@
 			vp = NULL;
 		}
 
-		if (newexi)
+		if (newexi) {
+			exi_rele(newexi);
 			newexi = NULL;
+		}
 
 		rddir_result_size -= dp->d_reclen;
 
@@ -1490,6 +1493,11 @@
 		rddir_next_offset = dp->d_off;
 	}
 
+	if (newexi) {
+		exi_rele(newexi);
+		newexi = NULL;
+	}
+
 	/*
 	 * Check for the case that another VOP_READDIR() has to be done.
 	 * - no space encoding error
